
// listctrltestDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "listctrltest.h"
#include "listctrltestDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CListctrlTestDlg dialog



CListctrlTestDlg::CListctrlTestDlg(CWnd* pParent /*=nullptr*/)
	: CDialog(IDD_LISTCTRLTEST_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListctrlTestDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST_CTRL, m_lstCtrl);
}

BEGIN_MESSAGE_MAP(CListctrlTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()


// CListctrlTestDlg message handlers

BOOL CListctrlTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    const int iMaxColumns = 15;

    for (int iIdx = 0; iIdx < iMaxColumns; ++iIdx)
    {
        CString strColText;
        strColText.Format(_T("Column %d"), iIdx);
        m_lstCtrl.InsertColumn(iIdx, strColText);
        m_lstCtrl.SetColumnWidth(iIdx, LVSCW_AUTOSIZE_USEHEADER);
    }

    const int iMaxRows = 20;

    for (int iIdxRows = 0; iIdxRows < iMaxRows; ++iIdxRows)
    {
        CString str;
        str.Format(_T("Row %d Column %d"), iIdxRows, 0);
        VERIFY( -1 != m_lstCtrl.InsertItem(iIdxRows, str));
        
        for (int iIdxCols = 1; iIdxCols < iMaxColumns; ++iIdxCols)
        {
            str.Format(_T("Row %d Column %d"), iIdxRows, 0);
            VERIFY(m_lstCtrl.SetItemText(iIdxRows, iIdxCols, str));
        }
    }

    for (int iIdx = 0; iIdx < iMaxColumns; ++iIdx)
    {
        m_lstCtrl.SetColumnWidth(iIdx, LVSCW_AUTOSIZE);
    }

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListctrlTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListctrlTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListctrlTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

